/*
 * tbinintop.C - 'template' for a binary int operator, included separately for (logical) And, Or
 */

void OPFNAME(Tobject& c, const Tobject& a, const Tobject& b) {
	int i,N;
	Tint I;
	switch (pair(a.kind(),b.kind())) {
	case pair(Kint,Kint):
		c = OP(a.i,b.i);
		gl_nops++;
		break;
	case pair(Kint,KIntArray):
		{
			c.copydimsIntArray(b);
			I = a.i;
			N = b.dims().length();
			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
			for (i=0; i<N; i++) cp[i] = OP(I,bp[i]);
			gl_nops+= N;
		}
		break;
	case pair(KIntArray,Kint):
		{
			c.copydimsIntArray(a);
			N = a.dims().length();
			I = b.i;
			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
			for (i=0; i<N; i++) cp[i] = OP(ap[i],I);
			gl_nops+= N;
		}
		break;
	case pair(KIntArray,KIntArray):
		{
			c.copydimsIntArray(a);
			N = a.dims().length();
			if (N != b.dims().length()) LengthError(OPCHAR,a,b);
			Tint *cp=c.IntPtr(), *ap=a.IntPtr(), *bp=b.IntPtr();
			for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
			gl_nops+= N;
		}
		break;
	default:
		BinError(OPCHAR,a,b);
		break;
	}
}
