/*
 * tunop.C - 'template' for a kind-preserving unary operator, included separately for -,...
 */

void OPFNAME(Tobject& c, const Tobject& a) {
	int i;
	switch (a.kind()) {
	case Kint:
		c = OP(a.i);
		gl_nops++;
		break;
	case Kreal:
		c = OP(a.x);
		gl_nops++;
		break;
	case Kcomplex:
		c = OP(a.z);
		gl_nops++;
		break;
	case KIntArray:
		{
			c.copydimsIntArray(a);
			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
			for (i=0; i<a.dims().length(); i++) cp[i] = OP(ap[i]);
			gl_nops+= a.dims().length();
		}
		break;
	case KRealArray:
		{
			c.copydimsRealArray(a);
			Treal *cp=c.RealPtr(), *ap=a.RealPtr();
			for (i=0; i<a.dims().length(); i++) cp[i] = OP(ap[i]);
			gl_nops+= a.dims().length();
		}
		break;
	case KComplexArray:
		{
			c.copydimsComplexArray(a);
			Tcomplex *cp=c.ComplexPtr(), *ap=a.ComplexPtr();
			for (i=0; i<a.dims().length(); i++) cp[i] = OP(ap[i]);
			gl_nops+= a.dims().length();
		}
		break;
	case KObjectArray:
	case Kfunction:
	case KCfunction:
	case Kvoid:
	case Kundef:
		UnaryError(OPCHAR,a);
		break;
	}
}
