/*
 * tunop1.C - 'template' for a kind-preserving unary operator that is applied to one object.
 * Included separately for Inc,Dec.
 */

void OPFNAME(Tobject& a) {
	int i;
	switch (a.kind()) {
	case Kint:
		OP(a.i);
		gl_nops++;
		break;
	case Kreal:
		OP(a.x);
		gl_nops++;
		break;
	case Kcomplex:
		OP(a.z);
		gl_nops++;
		break;
	case KIntArray:
		for (i=0; i<a.dims().length(); i++) OP(a.IntPtr()[i]);
		gl_nops+= a.dims().length();
		break;
	case KRealArray:
		for (i=0; i<a.dims().length(); i++) OP(a.RealPtr()[i]);
		gl_nops+= a.dims().length();
		break;
	case KComplexArray:
		for (i=0; i<a.dims().length(); i++) OP(a.ComplexPtr()[i]);
		gl_nops+= a.dims().length();
		break;
	case KObjectArray:
	case Kfunction:
	case KCfunction:
	case Kvoid:
	case Kundef:
		UnaryError(OPCHAR,a);
		break;
	}
}
