/*
 * This file is part of tela the Tensor Language.
 * Copyright (c) 1994-1995 Pekka Janhunen
 */

/*
 * tunrealop.C - 'template' for a transform-to-real unary operator, included separately for sin,cos,...
 */

void OPFNAME(Tobject& c, Tobject& a) {
	int i,N;
	switch (a.kind()) {
	case Kint:
		c = OP(a.IntValue());
		global::nops++;
		break;
	case Kreal:
		c = OP(a.RealValue());
		global::nops++;
		break;
	case Kcomplex:
		c = OP(a.ComplexValue());
		global::nops++;
		break;
	case KIntArray:
		N = a.length();
		if (&c==&a) {
			Tobject c1;
			c1.copydimsRealArray(a);
			Treal *c1p=c1.RealPtr(); Tint *ap=a.IntPtr();
			for (i=0; i<N; i++) c1p[i] = OP(ap[i]);
			//c = c1;
			c.bitwiseMoveFrom(c1);
		} else {
			c.copydimsRealArray(a);
			Treal *cp=c.RealPtr(); Tint *ap=a.IntPtr();
			for (i=0; i<N; i++) cp[i] = OP(ap[i]);
		}
		global::nops+= N;
		break;
	case KRealArray:
		{
			N = a.length();
			if (&c!=&a) c.copydimsRealArray(a);
			Treal *cp=c.RealPtr(), *ap=a.RealPtr();
			for (i=0; i<N; i++) cp[i] = OP(ap[i]);
			global::nops+= N;
		}
		break;
	case KComplexArray:
		{
			N = a.length();
			if (&c!=&a) c.copydimsComplexArray(a);
			Tcomplex *cp=c.ComplexPtr(), *ap=a.ComplexPtr();
			for (i=0; i<N; i++) cp[i] = OP(ap[i]);
			global::nops+= N;
		}
		break;
	case KObjectArray:
	case Kfunction:
	case KCfunction:
	case Kvoid:
	case Kundef:
		UnaryError(OPCHAR,a);
		break;
	}
}
